<template>
    <v-row justify="center" class="bee-gray" style="width: 100%; position: absolute;">
        <v-col cols="8" class="filled">
            <v-row align="center">
                <v-col cols="1">
                    <a @click="$router.go(-1)">
                        <img width="70px" src="~@/assets/icons/regresar.svg" alt srcset />
                    </a>
                </v-col>
                <v-col cols="1">
                    <h5 class="tit">Regresar</h5>
                </v-col>
            </v-row>

            <v-row no-gutters>
                <div class="d-flex black" style="width:100%;">
                    <h1 class="ml-10 white--text">CATÁLOGO</h1>
                </div>
            </v-row>
            <v-form ref="form" v-model="validForm" lazy-validation>
                <v-row class="bordered" no-gutters>
                    <v-row class>
                        <v-col cols="8">
                            <v-row class="mx-1">
                                <v-col>
                                    <v-text-field
                                        v-model="menu.name"
                                        :rules="[v => !!v || 'Campo requerido']"
                                        label="Nombre"
                                        required
                                        class="txt1"
                                    ></v-text-field>
                                </v-col>
                                <v-col>
                                    <v-text-field
                                        v-model="menu.description"
                                        label="Descripcion"
                                        class="txt2"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row class="mx-1">
                                <v-col cols="6">
                                    <v-input :messages="['Color principal']" class="inp1"></v-input>
                                    <div class="text-center">
                                        <v-list-group offset-y class="cpick1">
                                            <template v-slot:activator="{ on }">
                                                <v-btn :color="color" dark v-on="on">
                                                    Color
                                                </v-btn>
                                            </template>
                                            <v-color-picker
                                                v-model="menu.mainColor"
                                                :mode="mode"
                                                class="ma-2"
                                                show-swatches
                                            ></v-color-picker>
                                        </v-list-group>
                                    </div>
                                </v-col>
                                <v-col cols="6">
                                    <v-input class="inp2" :messages="['Color de texto de botón']"></v-input>
                                    <div class="text-center">
                                        <v-list-group offset-y class="cpick1">
                                            <template v-slot:activator="{ on }">
                                                <v-btn :color="color" dark v-on="on">
                                                    Color
                                                </v-btn>
                                            </template>
                                            <v-color-picker
                                                v-model="menu.buttonTextColor"
                                                :mode="mode"
                                                class="ma-2"
                                                show-swatches
                                            ></v-color-picker>
                                        </v-list-group>
                                    </div>
                                </v-col>
                            </v-row>
                            <v-row no-gutters>
                                <div class="d-flex mx-5 mb-5" style="align-items:center;">
                                    <HexCheckBox v-model="menu.useLogin"></HexCheckBox>
                                    <span class="mobileFont">Activar inicio de sesión</span>
                                </div>
                            </v-row>
                            <v-row no-gutters>
                                <div class="d-flex mx-5 mb-5" style="align-items:center;">
                                    <HexCheckBox v-model="menu.showChefRecommended"></HexCheckBox>
                                    <span class="mobileFont">Activar recomendaciones</span>
                                </div>
                            </v-row>
                            <v-row no-gutters>
                                <div class="d-flex mx-5 mb-5" style="align-items:center;">
                                    <HexCheckBox v-model="menu.showMostSelled"></HexCheckBox>
                                    <span class="mobileFont">Activar más vendidos</span>
                                </div>
                            </v-row>
                            <v-row no-gutters>
                                <div class="d-flex mx-5 mb-5" style="align-items:center;">
                                    <HexCheckBox v-model="menu.showReviews"></HexCheckBox>
                                    <span class="mobileFont">Activar Reviews</span>
                                </div>
                            </v-row>
                        </v-col>
                        <v-col>
                            <v-row class="m-1">
                                <v-col cols="6">
                                    <span class="mobileFont">Logo</span>
                                    <v-file-input
                                        accept="image/*"
                                        outlined
                                        placeholder="Subir Imagen"
                                        prepend-icon
                                        v-model="fileLogo"
                                        class="finp1"
                                    ></v-file-input>
                                    <span class="mobileFont">Imagen 1000x1000</span>
                                    <br />
                                    <span class="mobileFont">max 1mega</span>
                                    <br />
                                    <v-btn
                                        class="upimg1"
                                        color="#fdb947"
                                        rounded
                                        @click="uploadFile(pathLogo, fileLogo)"
                                        >Subir Imagen</v-btn
                                    >
                                </v-col>
                                <v-col cols="6">
                                    <span class="mobileFont">Fondo de pantalla</span>

                                    <v-file-input
                                        class="finp2"
                                        accept="image/*"
                                        label=""
                                        outlined
                                        prepend-icon
                                        placeholder="Subir Imagen"
                                        v-model="fileBackground"
                                    ></v-file-input>
                                    <span class="mobileFont">Imagen 1000x1000</span>
                                    <br />
                                    <span class="mobileFont">max 1mega</span>
                                    <br />
                                    <v-btn
                                        class="upimg"
                                        color="#fdb947"
                                        rounded
                                        @click="uploadFile(pathBackground, fileBackground)"
                                        >Subir Imagen</v-btn
                                    >
                                </v-col>
                            </v-row>
                        </v-col>
                    </v-row>
                    <v-container>
                        <v-btn :disabled="!validForm" color="#fdb947" rounded class="mr-4" @click="updateMenu"
                            >Guardar</v-btn
                        >
                    </v-container>
                </v-row>
            </v-form>
            <languages class="bordered" @setMessage="setMessage" :langMenus="langsMenu" :menu-id="menu.id"></languages>
            <categories
                class="bordered"
                @setMessage="setMessage"
                :categories="categoriesMenu"
                :langsMenu="langsMenu"
                :menuId="menu.id"
            ></categories>
        </v-col>
        <v-dialog v-model="message.show" rounded="" max-width="290">
            <v-alert
                style="text-align:center; margin:0px;"
                justify="center"
                v-model="message.show"
                dismissible
                :type="message.type"
                >{{ message.message }}</v-alert
            >
        </v-dialog>
    </v-row>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { namespace } from 'vuex-class';
import { Category } from '@/model/menu/Category';
import { LangMenu } from '@/model/menu/LangMenu';
import { db } from '@/config/firebase';
import { CATEGORIES, MENU_LANG, MENUS, STORAGE_BACKGROUND, STORAGE_LOGO } from '@/config/collectionsName';
import { serializeCategory, serializeLangMenu } from '@/config/serializables';
import { Menu as ModelMenu } from '@/model/menu/Menu';
import { MenuService } from '@/services/MenuService';
import Categories from '@/components/menu/Categories.vue';
import HexCheckBox from '@/components/commons/HexCheckBox.vue';
import Languages from '@/components/menu/Languages.vue';

const menuStore = namespace('MenuModule');

@Component({ components: { Categories, Languages, HexCheckBox } })
export default class Menu extends Vue {
    @menuStore.State
    menu!: ModelMenu;

    @menuStore.Action
    findMenuById!: (menuId: string) => Promise<void>;

    private readonly menuService = new MenuService();
    categoriesMenu: Category[] = [];
    langsMenu: LangMenu[] = [];
    validForm = true;
    fileLogo = new File([], '', undefined);
    fileBackground = new File([], '', undefined);
    pathLogo = STORAGE_LOGO;
    pathBackground = STORAGE_BACKGROUND;
    message: { message: string; type: 'success' | 'info' | 'warning' | 'error'; show: boolean } = {
        message: '',
        type: 'error',
        show: false
    };
    mode = 'hexa';

    color = '#1976D2FF';

    async created() {
        await this.findMenuById(this.$route.params.id);

        await this.$bind(
            'categoriesMenu',
            db
                .collection(MENUS)
                .doc(this.$route.params.id)
                .collection(CATEGORIES),
            { serialize: serializeCategory, reset: false }
        );

        await this.$bind(
            'langsMenu',
            db
                .collection(MENUS)
                .doc(this.$route.params.id)
                .collection(MENU_LANG),
            { serialize: serializeLangMenu }
        );
    }

    async updateMenu() {
        await this.menuService.updateMenu({
            id: this.menu.id,
            name: this.menu.name,
            description: this.menu.description,
            buttonTextColor: this.menu.buttonTextColor,
            mainColor: this.menu.mainColor,
            showChefRecommended: this.menu.showChefRecommended,
            showMostSelled: this.menu.showMostSelled,
            showReviews: this.menu.showReviews,
            useLogin: this.menu.useLogin
        });
        this.message = { message: 'MENÚ ACTUALIZADO', type: 'success', show: true };
    }

    async uploadFile(path: string, file: File) {
        try {
            await this.menuService.updateMenuFile(this.menu, file, path);
            this.message = { message: 'ARCHIVO ACTUALIZADO', type: 'success', show: true };
        } catch (e) {
            const error = e as Error;
            this.message = { message: error.message, type: 'error', show: true };
        }
    }

    setMessage(message: string, type: 'success' | 'info' | 'warning' | 'error') {
        this.message = { message, type, show: true };
    }
}
</script>

<style type="text/css">
.bee-gray {
    zoom: 100%;
    margin-bottom: 200px;
}
@media (max-width: 700px) {
    .tit {
        margin-left: 58px;
        position: absolute;
        font-size: 12px;
    }
    .mt-5 {
        position: absolute;
        width: 100px;
    }
    .v-btn__content {
        font-size: 7px;
    }
    .upimg {
        width: 70px;
    }
    .upimg1 {
        width: 70px;
    }
    .txt1 {
        position: absolute;
        margin-top: 30px;
        width: 100px;
        font-size: 12px;
    }
    .txt2 {
        position: absolute;
        margin-top: 30px;
        width: 170px;
        font-size: 12px;
    }
    .inp1 {
        margin-top: 30px;
    }
    .inp2 {
        margin-top: 30px;
    }
    .cpick1 {
        background: url('https://img.icons8.com/ios/50/000000/down-squared--v2.png') no-repeat;
        width: 50px;
    }
    .v-color-picker {
        width: 170px;
        height: 400px;
    }
    .finp1 {
        width: 150px;
    }
    .finp2 {
        width: 80px;
    }
    .mobileFont {
        font-size: 10px;
        position: absolute;
    }
    .filled {
        position: absolute;
        max-width: 850px;
    }
}
@media screen and (max-width: 800px) {
    .tit {
        width: 100px;
        height: 100px;
        margin-left: 58px;
        position: absolute;
    }
    .filled {
        position: absolute;
        max-width: 850px;
        max-height: 1500px;
        height: 1250px;
    }

    .mobileFont {
        font-size: 10px;
    }
    .upimg1 {
        width: 100px;
        font-size: 10px;
        position: relative;
    }
    .v-btn.v-size--default {
        font-size: 8px;
    }
}
@media screen and (max-width: 1240px) {
    .filled {
        position: absolute;
        max-width: 850px;
        max-height: 1500px;
        margin-bottom: 200px;
        height: 1250px;
    }

    .mobileFont {
        font-size: 10px;
    }
    .upimg1 {
        width: 100px;
        font-size: 10px;
        position: relative;
    }
    .v-btn.v-size--default {
        font-size: 8px;
    }
}
</style>
